﻿Imports PluginCalculator.Plugins

''' <summary>
''' Summenplugin
''' </summary>
Public Class Sum : Implements Plugin 'Plugin implementieren
    Public Function Calculate(ByVal x As Double, ByVal y As Double) As Double Implements Plugins.Plugin.Calculate
        Return x + y 'Berechnung durchführen
    End Function

    Public ReadOnly Property OperatorName() As String Implements Plugins.Plugin.OperatorName
        Get
            Return "+" 'Operator zurückgeben
        End Get
    End Property
End Class

Public Class Difference : Implements Plugin
    Public Function Calculate(ByVal x As Double, ByVal y As Double) As Double Implements Plugins.Plugin.Calculate
        Return x - y
    End Function

    Public ReadOnly Property OperatorName() As String Implements Plugins.Plugin.OperatorName
        Get
            Return "-"
        End Get
    End Property
End Class

Public Class Product : Implements Plugin
    Public Function Calculate(ByVal x As Double, ByVal y As Double) As Double Implements Plugins.Plugin.Calculate
        Return x * y
    End Function

    Public ReadOnly Property OperatorName() As String Implements Plugins.Plugin.OperatorName
        Get
            Return "*"
        End Get
    End Property
End Class

Public Class Quotient : Implements Plugin
    Public Function Calculate(ByVal x As Double, ByVal y As Double) As Double Implements Plugins.Plugin.Calculate
        If y = 0 Then Throw New Exception("Division durch 0")

        Return x / y
    End Function

    Public ReadOnly Property OperatorName() As String Implements Plugins.Plugin.OperatorName
        Get
            Return "/"
        End Get
    End Property
End Class